<?php

namespace common\logic\User\CreditHistory\Event;

use common\logic\Order\Order\Event\OrderDeleteEvent;
use common\logic\Order\Order\Model\Order;
use common\logic\User\CreditHistory\Wrapper\CreditHistoryManager;
use common\logic\User\User\Wrapper\UserManager;
use justcoded\yii2\eventlistener\observers\Observer;

class OrderObserver extends Observer
{
    public function events()
    {
        return [
            Order::EVENT_DELETE => 'onOrderDelete'
        ];
    }

    public function onOrderDelete(OrderDeleteEvent $event)
    {
        $order = $event->order;
        $creditHistoryManager = CreditHistoryManager::getInstance();
        $userManager = UserManager::getInstance();

        $creditHistoryManager->refundOrder($order, $userManager->getCurrent());
    }
}